package com.jah0wl.catan.fields;

import javax.microedition.lcdui.Graphics;
import com.jah0wl.utils.Point;

public class Terrain extends Field
{
	public static final int LUMBER =0;
	public static final int WOOL =1;
	public static final int GRAIN =2;
	public static final int BRICK =3;
	public static final int STONE =4;
	public static final int GOLD =5;
		
	public static final String[] resources =
//		{"madera","lana","trigo","ladrillo","piedra","oro"};
		{"lumber","wool","grain","brick","stone","gold"};

	private int resource;
	private int value;
		
	// Constructor
	public Terrain(Point p, int r, int rec, int v){
		this(p.x,p.y,r,rec,v);
	}	
	public Terrain(int x, int y, int r, int rec, int v){
		super(x,y,r);
		resource =rec;
		value =v;
	}
	
	//
	public void setResource(int r){
		resource =r;
	}
	
	public int getResource(){
		return resource;
	}	
	
	public void setValue(int v){
		value =v;
	}
	
	public int getValue(){
		return value;
	}

    //todo make it a utility method in games canvas and use instead of mininumbers
    private void drawNumber(Graphics g,int n,int x,int y){
		int newX;
        int cx = g.getClipX();
        int cy = g.getClipY();
        int width = g.getClipWidth();
		int height = g.getClipHeight();			
		if (n>=10){
			int xUno=(n==11)?x-1:x-2;   // uno=one,merge,join
			if (n==10)
				newX = (10-2)*5+3;
			else if (n==11)
				newX = 0;
			else // n==12
				newX = (2-2)*5+3;
			g.setClip(xUno-(3/2),y-(7/2),3,7);
			g.drawImage(numberImage,xUno-(3/2),y-(7/2),g.TOP|g.LEFT);
			g.setClip(x+1-(((n==11)?3:5)/2),y-(7/2),(n==11)?3:5,7);
			g.drawImage(numberImage,x+1-(((n==11)?3:5)/2)-newX,y-(7/2),g.TOP|g.LEFT);
		}else{
			newX = (n-2)*5+3;		
			g.setClip(x-(5/2),y-(7/2),5,7);
			g.drawImage(numberImage,x-(5/2)-newX,y-(7/2),g.TOP|g.LEFT);
		}
		g.setClip(cx,cy,width,height);
	}
	
	// draw hexagon // Pinta el hexgono
	public void paint(Graphics g){
		int width = g.getClipWidth();
		int height = g.getClipHeight();
		g.setClip(x-(17/2),y-(13/2),17,13);
		g.drawImage(fieldImage,x-(17/2)-(resource *17),y-(13/2),g.TOP|g.LEFT);
		g.setClip(0,0,width,height);
		drawNumber(g,value,x,y);
		if (value ==6 || value == 8){
			g.setColor(255,0,0);
			g.drawLine(x-1,y-2,x+1,y-2);
			g.drawLine(x-1,y,x+1,y);
			g.drawLine(x-1,y+2,x+1,y+2);
			g.drawLine(x-1,y-2,x-1,y+2);
			g.drawLine(x+1,y+1,x+1,y+1);
			if (value == 8)
				g.drawLine(x+1,y-1,x+1,y-1);				
		}			
	}	
}
