package com.jah0wl.catan.fields;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import java.io.IOException;
import com.jah0wl.utils.*;

public abstract class Field extends Hexagon{
	
	protected static Image fieldImage =null;
	protected static Image numberImage;
	
	// Constructor
	public Field(){
		this(0,0,0);	
	}
	public Field(int r){
		this(0,0,r);	
	}	
	public Field(Point p, int r){
		this(p.x,p.y,r);
	}
	public Field(int x, int y, int r){
		super(x,y,r);
		if (fieldImage ==null)
			try{
				fieldImage = Image.createImage("/fields.png");
				numberImage = Image.createImage("/numbers.png");
			}catch (IOException e){}		
	}	
			
	// other operations //Otras operaciones
	public abstract void paint(Graphics g);
}	